--
-- A level for Enigma: The Dark Outside
--
-- Copyright (c) 2005 Andreas Lochmann
-- License: GPL v.2
-- Created with the help of BBE 1.05

Require("levels/ant.lua")
function file_oxyd(x,y,f)
    oxyd_default_flavor=f
    oxyd(x,y)
end
levelh=25
levelw=39
enigma.FlatForce=30
enigma.SlopeForce=30
enigma.ElectricForce=30
cells={}
items={}
actors={}
stones={}
actors[" "]=cell{}
stones[" "]=cell{}
cells[" "]=cell{}
items[" "]=cell{}
cells["!"]=cell{floor="fl-brick"}
stones["!"]=cell{stone="st-rock4"}
cells["#"]=cell{floor="fl-abyss"}
function ac_blackball(x,y)
n=""
p=0
f=0
 if (x==1) and (y==1) then
  n="ac1x1"
  p=0
  mf=1,66666666666667
 end
set_actor("ac-blackball",x+0.5,y+0.5,{player=p,name=n,mouseforce=mf})
end
actors["!"]=cell{parent={{ac_blackball}}}
--stones["#"]=cell{stone="st-invisible"}
stones["#"]=cell{stone="st-stonebrush"}
items["!"]=cell{item="it-brush"}
stones["$"]=cell{parent={{file_oxyd,"a"}}}
level={"!!!!!!!!!!!!!!!!!!!!!!!!!!!############",
       "!!!!!!!!!!!!!!!!!!!!!!!!!!!############",
       "!!!!!!!!!!!!!!!!!!!!!!!!!!!############",
       "!!!!!!!!!!!!!!!!!!!!!!!!!!!############",
       "!!!!!!!!!!!!!!!!!!!!!!!!!!!############",
       "!!!!!!!!!!!!!!!!!!!!!!!!!!!############",
       "!!!!!!!!!!!!!!!!!!!!!!!!!!!############",
       "!!!!!!!!!!!!!!!!!!!!!!!!!!!############",
       "!!!!!!!!!!!!!!!!!!!!!!!!!!!############",
       "!!!!!!!!!!!!!!!!!!!!!!!!!!!############",
       "!!!!!!!!!!!!!!!!!!!!!!!!!!!############",
       "!!!!!!!!!!!!!!!!!!!!!!!!!!!############",
       "!!!!!!!!!!!!!!!!!!!!!!!!!!!############",
       "#######################################",
       "#######################################",
       "#######################################",
       "#######################################",
       "#######################################",
       "#######################################",
       "#######################################",
       "#######################################",
       "#######################################",
       "#######################################",
       "#######################################",
       "#######################################"}
   acmap={"                                       ",
          " !                                     ",
          "                                       ",
          "                                       ",
          "                                       ",
          "                                       ",
          "                                       ",
          "                                       ",
          "                                       ",
          "                                       ",
          "                                       ",
          "                                       ",
          "                                       ",
          "                                       ",
          "                                       ",
          "                                       ",
          "                                       ",
          "                                       ",
          "                                       ",
          "                                       ",
          "                                       ",
          "                                       ",
          "                                       ",
          "                                       ",
          "                                       "}
  itmap={"                                       ",
         "                                       ",
         "                                       ",
         "                                       ",
         "                                       ",
         "                                       ",
         "                                       ",
         "                                       ",
         "                                       ",
         "                                       ",
         "                                       ",
         "                                       ",
         "                                       ",
         "                                       ",
         "                                       ",
         "                                       ",
         "                                       ",
         "                                       ",
         "                                       ",
         "                                       ",
         "                                       ",
         "                                       ",
         "                                       ",
         "                                       ",
         "                                       "}
 stmap={"!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!",
        "!  #      #        #                  !",
        "!  #   #  ###   ####                  !",
        "!  #####    #   #                     !",
        "!        #  # # #  #                  !",
        "!######  #    # #  #                  !",
        "!     #  # #  # #  #                  !",
        "!   # # ## #  # #  #                  !",
        "!   # ###  #### #  #                  !",
        "!## #      #    #  #                  !",
        "!   #   #### ####  #                  !",
        "!   #      #       #                  !",
        "!!!!!!!!!!!!!!!!!!!!!!!!!!!           !",
        "!                                     !",
        "!                                     !",
        "!                                     !",
        "!                                     !",
        "!                                     !",
        "!                                     !",
        "!  $                             $    !",
        "!                                     !",
        "!                                     !",
        "!                                     !",
        "!                                     !",
        "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"}
create_world_by_map(level)
draw_map(0,0,stmap,stones)
draw_map(0,0,itmap,items)
draw_map(0,0,acmap,actors)

randomseed( enigma.GetTicks() )

--colour = {}
uhrlaeuft = 1.0
richtung = 1.0
posx = 1.0
posy = 10.0
zerstoert = 0.0
count = 0
malen = 0
--if difficult then
--  TIMERINT = 0.6
--else
  TIMERINT = 0.8
--end

function timercallback()
  if (uhrlaeuft == 1.0) and (zerstoert == 0.0) then
    kill_stone(posx,posy)
    --if random(1,3) == 1 then
    count = count + 1
    if count == 5 then
      if difficult then
        richtung = richtung + 1
        if richtung == 5 then richtung = 1 end
        count = 1
      else
        richtung = richtung - 1
        if richtung == 0 then richtung = 4 end
        count = 1
      end
    end
    oldposx = posx
    oldposy = posy
    if richtung == 1.0 then  posy = posy - 1  end
    if richtung == 2.0 then  posx = posx + 1  end
    if richtung == 3.0 then  posy = posy + 1  end
    if richtung == 4.0 then  posx = posx - 1  end
    --if posx > 15 then posx = 15  end
    --if posx < 1 then posx = 1  end
    --if posy > 11 then posy = 11  end
    --if posy < 1 then posy = 1  end
    hier = enigma.GetStone(posx,posy)
    if not(hier == nil) then
      posx = oldposx
      posy = oldposy
    end
    set_stone("st-fourswitch",posx,posy, {action="callback", target="hitclock"})
    mir = enigma.GetStone(posx,posy)
    richtung2=richtung
    richtung=1
    for j=1,richtung2+3 do
      SendMessage(mir, "trigger")
    end
    teilchen = enigma.GetItem(posx,posy)
    if not(teilchen == nil) then
      if teilchen == enigma.GetNamedObject("thisbrush") then
        malen = 1
        kill_item(posx,posy)
      end
    end
    if malen == 1 then
      set_floor("fl-concrete", posx, posy)
    end    
  end
end

function hitclock()
  richtung = richtung + 1.0
  if richtung == 5.0 then
    richtung = 1.0
  end
end

set_stone("st-timer", 0, 0, {action="callback", target="timercallback", interval=TIMERINT} )
set_stone("st-fourswitch",posx,posy, {action="callback", target="hitclock"})
set_item("it-brush", 2, 3, {name="thisbrush"})

oxyd_shuffle()
